=== debian/control ===
Source: suitesparse-graphblas
Maintainer: Debian Science Team <debian-science-maintainers@alioth-lists.debian.net>
Uploaders: Vincent Prat <vivi@debian.org>
Section: math
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               texlive-latex-base,
               texlive-latex-extra
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/science-team/suitesparse-graphblas
Vcs-Git: https://salsa.debian.org/science-team/suitesparse-graphblas.git
Homepage: https://faculty.cse.tamu.edu/davis/GraphBLAS.html
Rules-Requires-Root: no

Package: libgraphblas6
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: graph algorithms in the language of linear algebra - shared library
 SuiteSparse:GraphBLAS is a complete implementation of the GraphBLAS standard,
 which defines a set of sparse matrix operations on an extended algebra of
 semirings using an almost unlimited variety of operators and types. When
 applied to sparse adjacency matrices, these algebraic operations are
 equivalent to computations on graphs. GraphBLAS provides a powerful and
 expressive framework for creating graph algorithms based on the elegant
 mathematics of sparse matrix operations on a semiring.
 .
 This package contains the shared library.

Package: libgraphblas-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Breaks: libsuitesparse-dev (<< 1:5.10.1+dfsg-3)
Replaces: libsuitesparse-dev (<< 1:5.10.1+dfsg-3)
Depends: ${misc:Depends},
         libgraphblas6 (= ${binary:Version})
Description: graph algorithms in the language of linear algebra - development files
 SuiteSparse:GraphBLAS is a complete implementation of the GraphBLAS standard,
 which defines a set of sparse matrix operations on an extended algebra of
 semirings using an almost unlimited variety of operators and types. When
 applied to sparse adjacency matrices, these algebraic operations are
 equivalent to computations on graphs. GraphBLAS provides a powerful and
 expressive framework for creating graph algorithms based on the elegant
 mathematics of sparse matrix operations on a semiring.
 .
 This package contains the development files.

Package: libgraphblas-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: graph algorithms in the language of linear algebra - documentation
 SuiteSparse:GraphBLAS is a complete implementation of the GraphBLAS standard,
 which defines a set of sparse matrix operations on an extended algebra of
 semirings using an almost unlimited variety of operators and types. When
 applied to sparse adjacency matrices, these algebraic operations are
 equivalent to computations on graphs. GraphBLAS provides a powerful and
 expressive framework for creating graph algorithms based on the elegant
 mathematics of sparse matrix operations on a semiring.
 .
 This package contains the documentation.
