## suitesparse-graphblas 6.2.4+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -26,9 +26,9 @@
 set ( CMAKE_MACOSX_RPATH TRUE )
 
 # version of SuiteSparse:GraphBLAS
-set ( GraphBLAS_DATE "Jan 13, 2022" )
+set ( GraphBLAS_DATE "Mar 8, 2022" )
 set ( GraphBLAS_VERSION_MAJOR 6 )
-set ( GraphBLAS_VERSION_MINOR 1 )
+set ( GraphBLAS_VERSION_MINOR 2 )
 set ( GraphBLAS_VERSION_SUB   4 )
 
 message ( STATUS "Building SuiteSparse:GraphBLAS version: v" ${GraphBLAS_VERSION_MAJOR}.${GraphBLAS_VERSION_MINOR}.${GraphBLAS_VERSION_SUB}  " date: " ${GraphBLAS_DATE} )
@@ -102,9 +102,10 @@
 
 endif ( )
 
+# CUDA is under development for now, and not deployed in production:
+set ( CMAKE_CUDA off)
+
 # Edit these lines for code development only, not for end-users:
-# CUDA is under developent for now, and not deployed in production
-  set ( CMAKE_CUDA off )
 # set ( GBCOMPACT true )
 # set ( CMAKE_BUILD_TYPE Debug )
