=== Makefile ===
--- 
+++ 
@@ -29,6 +29,10 @@
 # just build the dynamic library, but not the demos
 library:
 	( cd build ; cmake $(CMAKE_OPTIONS) .. ; $(MAKE) --jobs=$(JOBS) )
+
+# compile with -g 
+debug:
+	( cd build ; cmake -DCMAKE_BUILD_TYPE=Debug $(CMAKE_OPTIONS) .. ; $(MAKE) --jobs=$(JOBS) )
 
 # build the dynamic library and the demos
 all:
