=== alternative/Makefile ===
--- 
+++ 
@@ -20,7 +20,7 @@
 
 # This version info must match ../CMakeLists.txt 
 VER1 = 6
-VER2 = 1
+VER2 = 2
 VER3 = 4
 
 # pick your compiler:
