=== debian/changelog ===
suitesparse-graphblas (6.2.4+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Vincent Prat <vivi@debian.org>  Thu, 10 Mar 2022 19:05:32 +0100
