=== debian/rules ===
#!/usr/bin/make -f

# Hardening options
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
CFLAGS := $(CFLAGS) $(CPPFLAGS)

# Flags for CMake
export CMAKE_OPTIONS := -DCMAKE_INSTALL_PREFIX=/usr

%:
	dh $@

override_dh_auto_build:
	# build docs
	make docs
	dh_auto_build
