## suitesparse-graphblas 7.2.0+dfsg

=== debian/changelog ===
suitesparse-graphblas (7.2.0+dfsg-2) unstable; urgency=medium

  * Source-only upload to enable migration to testing

 -- Vincent Prat <vivi@debian.org>  Tue, 30 Aug 2022 19:16:53 +0200

suitesparse-graphblas (7.2.0+dfsg-1) unstable; urgency=medium

  * New upstream release with SONAME bump
  * Update Standards-Version to 4.6.1 (no change needed)

 -- Vincent Prat <vivi@debian.org>  Sat, 27 Aug 2022 12:50:49 +0200
